// acis.hxx: ACIS class.
//
// Copyright (C) 1999-2001 Frank C Langbein <frank@langbein.org>
//
// This program is free software; you can redistribute it and/or modify it 
// under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: acis.hxx,v 1.7.2.1 2001/08/16 16:19:07 scmfcl Exp $

#ifndef ACIS_HXX
#define ACIS_HXX 1

#ifdef HAVE_ACIS_5
#include <kernel/geomhusk/acistol.hxx>
#include <kernel/kernutil/vector/position.hxx>
#include <kernel/kernutil/vector/transf.hxx>
#include <kernel/logical.h>
#endif // HAVE_ACIS_5

#ifdef HAVE_ACIS_6
#include <baseutil/vector/acistol.hxx>
#include <baseutil/vector/position.hxx>
#include <baseutil/vector/transf.hxx>
#endif // HAVE_ACIS_6

#include <kernel/acis.hxx>
#include <kernel/acis3dt.h>
#include <kernel/dcl_kern.h>
#include <kernel/geomhusk/acistype.hxx>
#include <kernel/kernapi/api/api.hxx>
#include <kernel/kernapi/api/kernapi.hxx>
#include <kernel/kerndata/attrib/attrib.hxx>
#include <kernel/kerndata/bulletin/bulletin.hxx>
#include <kernel/kerndata/data/datamsc.hxx> 
#include <kernel/kerndata/data/en_macro.hxx>
#include <kernel/kerndata/data/entity.hxx> 
#include <kernel/kerndata/geom/point.hxx>
#include <kernel/kerndata/geom/allcurve.hxx>
#include <kernel/kerndata/geom/allsurf.hxx>
#include <kernel/kerndata/geom/transfrm.hxx>
#include <kernel/kerndata/geom/intcurve.hxx>
#include <kernel/kerndata/lists/lists.hxx>
#include <kernel/kerndata/savres/fileinfo.hxx>
#include <kernel/kerndata/top/alltop.hxx>
#include <kernel/kernutil/errorsys/errorsys.hxx>
#include <kernel/meshhusk/geom/compcurv.hxx>
#include <kernel/spline/api/spl_api.hxx>
#include <ga_husk/api/ga_api.hxx>
#include <ga_husk/attrib/at_gen.hxx>
#include <ga_husk/attrib/at_name.hxx>
#include <ga_husk/attrib/at_str.hxx>
#include <intersct/kernapi/api/intrapi.hxx>
#include <constrct/kernapi/api/cstrapi.hxx>
#include <faceter/acisintf/fct_utl.hxx>
#include <faceter/api/af_api.hxx>
#include <faceter/attribs/refine.hxx> 
#include <faceter/meshmgr/idx_mesh.hxx>
#include <faceter/meshmgr/idx_mm.hxx>
#include <euler/kernapi/api/eulerapi.hxx>
#include <boolean/kernapi/api/boolapi.hxx>

#endif // !ACIS_HXX

/// Local Variables:
/// exe-comm: "../sil"
/// compile-command: "cd .. && make"
/// End:
