// at_color.hxx: ACIS color attribute.
//
// Copyright (C) 1999-2001 Frank C Langbein <frank@langbein.org>
//
// This program is free software; you can redistribute it and/or modify it 
// under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: at_material.hxx,v 1.5.2.1 2001/08/16 16:19:07 scmfcl Exp $

#ifndef AT_MATERIAL_HXX
#define AT_MATERIAL_HXX 1

#define ATTRIB_MATERIAL_CLASS

#include "acis/at_sil.hxx"
#include "material.hxx"

extern int ATTRIB_MATERIAL_TYPE; 

#define ATTRIB_MATERIAL_LEVEL (ATTRIB_SIL_LEVEL + 1) 

class ATTRIB_MATERIAL: public ATTRIB_SIL, public Material { 
public: 
  ATTRIB_MATERIAL (ENTITY *owner = NULL,
		   double ar=0.7, double ag=0.7, double ab=0.7, double aa=1.0,
		   double dr=0.7, double dg=0.7, double db=0.7, double da=1.0,
		   double sr=0.2, double sg=0.2, double sb=0.2, double sa=0.0,
		   double er=0.0, double eg=0.0, double eb=0.0, double ea=0.0,
		   double ss=1.0);
  void set_material (double ar, double ag, double ab, double aa,
		     double dr, double dg, double db, double da,
		     double sr, double sg, double sb, double sa,
		     double er, double eg, double eb, double ea,
		     double ss);
  // Functions called to aid attribute migration during modeling 
  // operations.
  virtual void split_owner(ENTITY*); 
  // The owner of this attribute is about to be split in two - the 
  // argument is the new piece. The owner of this attribute is about 
  // to be merged with the given entity. The logical argument is 
  // TRUE if the owner is to be deleted in the merge. 
  virtual void merge_owner (ENTITY*, logical); 
  ATTRIB_FUNCTIONS (ATTRIB_MATERIAL, NONE)
};

#endif // !AT_MATERIAL_HXX

/// Local Variables:
/// exe-comm: "../sil"
/// compile-command: "cd .. && make"
/// End:
