// at_sil.cc: SIL attributes implementation.
//
// Copyright (C) 1999-2001 Frank C Langbein <frank@langbein.org>
//
// This program is free software; you can redistribute it and/or modify it 
// under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: at_sil.cc 1 2005-08-10 23:35:07Z frank $

#include "config.h"

RCSID (at_sil, "$Id: at_sil.cc 1 2005-08-10 23:35:07Z frank $");

#include "acis/acis.hxx"

#include "acis/at_sil.hxx"

// Define macros for this attribute and its parent, to provide the 
// information to the definition macro. 
#define THIS() ATTRIB_SIL
#define THIS_LIB NONE
#define PARENT() ATTRIB 
#define PARENT_LIB KERN

// Identifier used externally to identify an particular entity 
// type. This is only used within the save/restore system for 
// translating to/from external file format, but must be unique 
// amongst attributes derived directly from ATTRIB, across all 
// application developers. 
#define ATTRIB_SIL_NAME "sil" 

MASTER_ATTRIB_DEFN ("sil master attribute");

/// Local Variables:
/// exe-comm: "../sil"
/// compile-command: "cd .. && make"
/// End:
