dnl aclocal.m4: Local modifications of Autoconf.     [-*- mode: autoconf -*-]
dnl
dnl Copyright (C) 1999-2001 Frank Langbein <frank@langbein.org>
dnl All rights reserved.
dnl
dnl This program is free software; you can redistribute it and/or modify it 
dnl under the terms of the GNU General Public License as published by the Free
dnl Software Foundation; either version 2 of the License, or (at your option)
dnl any later version.
dnl
dnl This program is distributed in the hope that it will be useful, but
dnl WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
dnl or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
dnl for more details.
dnl
dnl You should have received a copy of the GNU General Public License along
dnl with this program; if not, write to the Free Software Foundation, Inc.,
dnl 675 Mass Ave, Cambridge, MA 02139, USA.
dnl
dnl $Id: aclocal.m4,v 1.9.2.1 2001/08/16 16:19:04 scmfcl Exp $
dnl

dnl Note: These autoconf expansions are written for the autoconf version 2.12.
dnl They might not work with any other version.

dnl AC_SIL_CHECK_LIB(LIBRARY, FUNCTION [, ACTION-IF-FOUND
dnl                    [, ACTION-IF-NOT-FOUND [, OTHER-LIBRARIES]]])
dnl
dnl AC_SIL_CHECK_LIB is based on the autoconf macro AC_CHECK_LIB. The
dnl main difference is that we are also giving the proper prototypes for
dnl the functions and care for C++ compilers.
dnl
dnl It tries to ensure that the C function FUNCTION is available by checking
dnl whether a test C program with proper prototypes for the used functions
dnl can be linked with the library LIBRARY to get the function. LIBRARY
dnl is the base name of the library, e.g. to check for `-lf2c', use `f2c'.
dnl
dnl ACTION-IF_FOUND is a list of shell commands to run if the link with
dnl the library succeeds; ACTION-IF-NOT-FOUND is a list of shell commands
dnl to run if the link fails.  If ACTION-IF-FOUND and ACTION-IF-NOT-FOUND
dnl are not specified, the default action is to add `-lLIBRARY' to `LIBS'
dnl and define `HAVE_LIBLIBRARY' (in all capitals).
dnl
dnl If linking with LIBRARY results in unresolved symbols, which would be
dnl resolved by linking with additional libraries, give those libraries as
dnl the OTHER-LIBRARIES argument, separated by spaces: `-lXt -lX11'.
dnl Otherwise this macro will fail to detect that LIBRARY is present,
dnl because linking the test program will always fail with unresolved
dnl symbols.
dnl
AC_DEFUN(AC_SIL_CHECK_LIB,
[AC_MSG_CHECKING([for $2 in -l$1])
dnl Use a cache variable name containing both the library and function name,
dnl because the test really is for library $1 defining function $2, not
dnl just for library $1. Separate tests with the same $1 and different $2s
dnl may have different results.
ac_lib_var=`echo $1['_']$2 | sed 'y%./+-%__p_%'`
AC_CACHE_VAL(ac_cv_lib_$ac_lib_var,
[ac_save_LIBS="$LIBS"
LIBS="-l$1 $5 $LIBS"
AC_TRY_LINK(dnl
ifelse([$2], [main], , dnl Avoid conflicting decl of main.
[/* Override any gcc2 internal prototype to avoid an error.  */
]ifelse(AC_LANG, CPLUSPLUS, [#ifdef __cplusplus
extern "C"
#endif
])dnl
[/* We use char because int might match the return type of a gcc2
    builtin and then its argument prototype would still apply.  */
char $2 (void);
]),
  [$2()],
  eval "ac_cv_lib_$ac_lib_var=yes",
  eval "ac_cv_lib_$ac_lib_var=no")
LIBS="$ac_save_LIBS"
])dnl
if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
  AC_MSG_RESULT(yes)
  ifelse([$3], ,
[changequote(, )dnl
  ac_tr_lib=HAVE_LIB`echo $1 | sed -e 's/[^a-zA-Z0-9_]/_/g' \
    -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
changequote([, ])dnl
  AC_DEFINE_UNQUOTED($ac_tr_lib)
  LIBS="-l$1 $LIBS"
], [$3])
else
  AC_MSG_RESULT(no)
  ifelse([$4], , , [$4
])dnl
fi
])

dnl AC_SIL_C_CONST
dnl
dnl Check for the C const identifier. Define const to be empty if it is
dnl not provided by the C compiler.
dnl
dnl AC_SIL_C_CONST is based on AC_C_CONST. But the const charset x defined
dnl in the original test program was uninitialized. This causes an error
dnl message with g++ 2.95.1. So const was defined to be empty.
AC_DEFUN(AC_SIL_C_CONST,
[dnl This message is consistent in form with the other checking messages,
dnl and with the result message.
AC_CACHE_CHECK([for working const], ac_cv_c_const,
[AC_TRY_COMPILE(,
changequote(<<, >>)dnl
<<
/* Ultrix mips cc rejects this.  */
typedef int charset[2]; const charset x = {0, 0};
/* SunOS 4.1.1 cc rejects this.  */
char const *const *ccp;
char **p;
/* NEC SVR4.0.2 mips cc rejects this.  */
struct point {int x, y;};
static struct point const zero = {0,0};
/* AIX XL C 1.02.0.0 rejects this.
   It does not let you subtract one const X* pointer from another in an arm
   of an if-expression whose if-part is not a constant expression */
const char *g = "string";
ccp = &g + (g ? g-g : 0);
/* HPUX 7.0 cc rejects these. */
++ccp;
p = (char**) ccp;
ccp = (char const *const *) p;
{ /* SCO 3.2v4 cc rejects this.  */
  char *t;
  char const *s = 0 ? (char *) 0 : (char const *) 0;

  *t++ = 0;
}
{ /* Someone thinks the Sun supposedly-ANSI compiler will reject this.  */
  int x[] = {25, 17};
  const int *foo = &x[0];
  ++foo;
}
{ /* Sun SC1.0 ANSI compiler rejects this -- but not the above. */
  typedef const int *iptr;
  iptr p = 0;
  ++p;
}
{ /* AIX XL C 1.02.0.0 rejects this saying
     "k.c", line 2.27: 1506-025 (S) Operand must be a modifiable lvalue. */
  struct s { int j; const int *ap[3]; };
  struct s *b; b->j = 5;
}
{ /* ULTRIX-32 V3.1 (Rev 9) vcc rejects this */
  const int foo = 10;
}
>>,
changequote([, ])dnl
ac_cv_c_const=yes, ac_cv_c_const=no)])
if test $ac_cv_c_const = no; then
  AC_DEFINE(const, )
fi
])

dnl AC_SIL_C_INLINE
dnl
dnl Do nothing if the compiler accepts the inline keyword.
dnl Otherwise define inline to __inline__ or __inline if one of those work,
dnl otherwise define inline to be empty.
dnl
dnl AC_SIL_C_INLINE is based on AC_C_INILNE. But foo had no type in the
dnl original test program which casued an error message with
dnl gcc 2.95.1.
AC_DEFUN(AC_SIL_C_INLINE,
[AC_CACHE_CHECK([for inline], ac_cv_c_inline,
[ac_cv_c_inline=no
for ac_kw in inline __inline__ __inline; do
  AC_TRY_COMPILE(, [} $ac_kw int foo() {], [ac_cv_c_inline=$ac_kw; break])
done
])
case "$ac_cv_c_inline" in
  inline | yes) ;;
  no) AC_DEFINE(inline, ) ;;
  *)  AC_DEFINE_UNQUOTED(inline, $ac_cv_c_inline) ;;
esac
])

dnl AC_SIL_ACIS
dnl
dnl Checking for ACIS. The path can be set by the option --with-acis
dnl and it also checks if the environemtn variqble A3DT is set.
dnl
dnl It define HAVE_ACIS if the ACIS solid modelling kernel is found. 
dnl But note that this does not guarantee that any libraries/husks or
dnl headers are available. A3DT will be set to the path of acis, if one
dnl is found.
AC_DEFUN(AC_SIL_ACIS,dnl
[AC_CACHE_CHECK([for ACIS], ac_cv_sil_acis,dnl
[acispaths="/opt/acis:/usr/local/acis:/usr/acis"
if test "X$A3DT" != X; then
  acispaths="$A3DT:$acispaths"
fi
acisdefault="$acispaths"
AC_ARG_WITH(acis,
  [  --with-acis=acisdir     use acisdir as top level ACIS directory],
  acispaths="$withval")
ac_cv_sil_acis=""
for dir in `echo $acispaths | sed -e 's,:, ,g'`
do
  if test -d "$dir/kern"; then
    ac_cv_sil_acis="$dir"
    break
  fi
done
])
A3DT="$ac_cv_sil_acis"
AC_SUBST(A3DT)
if test "X$A3DT" != X; then
  AC_DEFINE(HAVE_ACIS)
fi
case "${host}" in
  i?86-*-linux*)   if test -d "$A3DT/lib/linux_so"; then
                     ACIS_ARCH="linux_so"
                   else
                     ACIS_ARCH="linux"
                   fi ;;
  *)               ACIS_ARCH="unknown" ;;
esac
AC_SUBST(ACIS_ARCH)
])

dnl AC_SIL_CHECK_ACIS_LIB
dnl
dnl Checks if specified ACIS library is available and sets ACIS_LIBS
dnl accordingly. Note that A3DT has to be defined before you can use
dnl this function.
dnl
dnl Note that this test only checks if the static library is available.
dnl It does not guarantee that the library can be used. Due to the
dnl complex library dependencies of ACIS this would be a very tricky test.
AC_DEFUN(AC_SIL_CHECK_ACIS_LIB,
[AC_REQUIRE([AC_SIL_ACIS])
AC_MSG_CHECKING([for ACIS library $1])
if test -r "$A3DT/lib/$ACIS_ARCH/lib$1.a" -o -r "$A3DT/lib/$ACIS_ARCH/lib$1.so"; then
  ACIS_LIBS="-l$1 $ACIS_LIBS"
  ac_sil_acis_lib=yes
  AC_MSG_RESULT(yes)
else
  ac_sil_acis_lib=no
  AC_MSG_RESULT(no)
fi
])

dnl AC_SIL_CHECK_ACIS_INC
dnl
dnl Checks if specified ACIS include path is available and sets ACIS_CPPFLAGS
dnl accordingly. Note that A3DT has to be defined before you can use
dnl this function.
AC_DEFUN(AC_SIL_CHECK_ACIS_INC,
[AC_REQUIRE([AC_SIL_ACIS])
AC_MSG_CHECKING([for ACIS include path $1])
if test -d "$A3DT/$1"; then
  ac_safe=`echo "$1" | sed 'y%./+-%__p_%' | tr 'a-z' 'A-Z'`
  ACIS_CPPFLAGS="-I$A3DT/$1 $ACIS_CPPFLAGS"
  AC_DEFINE_UNQUOTED(HAVE_ACIS_$ac_safe)
  AC_MSG_RESULT(yes)
else 
  AC_MSG_RESULT(no)
fi
])

dnl AC_SIL_C_BIGENDIAN
dnl
dnl If words are stored with the most significant byte first (like
dnl Motorola and SPARC, but not Intel and VAX, CPUs), define
dnl `WORDS_BIGENDIAN'.
dnl
dnl AC_SIL_C_BIGENDIAN is based on the AC_C_BIGENDIAN macro. The
dnl only difference is that we provide a default for cross compiling.
dnl As we use the BIGENDIAN test only for simulating the NAN code, this
dnl shouldn't cause any trouble unless the NAN code itself doesn't work
dnl on some machine.
AC_DEFUN(AC_SIL_C_BIGENDIAN,
[AC_CACHE_CHECK(whether byte ordering is bigendian, ac_cv_c_bigendian,
[ac_cv_c_bigendian=unknown
# See if sys/param.h defines the BYTE_ORDER macro.
AC_TRY_COMPILE([#include <sys/types.h>
#include <sys/param.h>], [
#if !BYTE_ORDER || !BIG_ENDIAN || !LITTLE_ENDIAN
 bogus endian macros
#endif], [# It does; now see whether it defined to BIG_ENDIAN or not.
AC_TRY_COMPILE([#include <sys/types.h>
#include <sys/param.h>], [
#if BYTE_ORDER != BIG_ENDIAN
 not big endian
#endif], ac_cv_c_bigendian=yes, ac_cv_c_bigendian=no)])
if test $ac_cv_c_bigendian = unknown; then
AC_TRY_RUN([main () {
  /* Are we little or big endian?  From Harbison&Steele.  */
  union
  {
    long l;
    char c[sizeof (long)];
  } u;
  u.l = 1;
  exit (u.c[sizeof (long) - 1] == 1);
}], ac_cv_c_bigendian=no, ac_cv_c_bigendian=yes, ac_cv_c_bigendian=no)
fi])
if test $ac_cv_c_bigendian = yes; then
  AC_DEFINE(WORDS_BIGENDIAN)
fi
])

dnl AC_SIL_STRUCT_TIMEVAL
dnl
dnl Check if we have struct timeval
AC_DEFUN(AC_SIL_STRUCT_TIMEVAL,
[AC_MSG_CHECKING(for struct timeval)
AC_CACHE_VAL(ac_sil_cv_struct_timeval,
[
AC_EGREP_HEADER(struct timeval, sys/time.h, ac_sil_cv_struct_timeval=yes,
                AC_EGREP_HEADER(struct timeval, time.h,
                                ac_sil_cv_struct_timeval=yes,
                                ac_sil_cv_struct_timeval=no))
])
AC_MSG_RESULT($ac_sil_cv_struct_timeval)
if test $ac_sil_cv_struct_timeval = yes; then
  AC_DEFINE(HAVE_TIMEVAL)
fi
])

dnl AC_SIL_CHECK_LIB_WITH_F2C(LIBRARY, FUNCTION [, ACTION-IF-FOUND
dnl                             [, ACTION-IF-NOT-FOUND [, OTHER-LIBRARIES]]])
dnl
dnl AC_SIL_CHECK_LIB_WITH_F2C is based on the autoconf macro AC_CHECK_LIB.
dnl The main difference is that we are also giving the proper prototypes for
dnl the functions, care for C++ compilers and set all the proper variables
dnl in the C code for Fortran77 / f2c.
dnl
dnl It tries to ensure that the C function FUNCTION is available by checking
dnl whether a test C program with proper prototypes for the used functions
dnl can be linked with the library LIBRARY to get the function. LIBRARY
dnl is the base name of the library, e.g. to check for `-lf2c', use `f2c'.
dnl
dnl ACTION-IF_FOUND is a list of shell commands to run if the link with
dnl the library succeeds; ACTION-IF-NOT-FOUND is a list of shell commands
dnl to run if the link fails.  If ACTION-IF-FOUND and ACTION-IF-NOT-FOUND
dnl are not specified, the default action is to add `-lLIBRARY' to `LIBS'
dnl and define `HAVE_LIBLIBRARY' (in all capitals).
dnl
dnl If linking with LIBRARY results in unresolved symbols, which would be
dnl resolved by linking with additional libraries, give those libraries as
dnl the OTHER-LIBRARIES argument, separated by spaces: `-lXt -lX11'.
dnl Otherwise this macro will fail to detect that LIBRARY is present,
dnl because linking the test program will always fail with unresolved
dnl symbols.
dnl
AC_DEFUN(AC_SIL_CHECK_LIB_WITH_F2C,
[AC_MSG_CHECKING([for $2 in -l$1])
dnl Use a cache variable name containing both the library and function name,
dnl because the test really is for library $1 defining function $2, not
dnl just for library $1.  Separate tests with the same $1 and different $2s
dnl may have different results.
ac_lib_var=`echo $1['_']$2 | sed 'y%./+-%__p_%'`
AC_CACHE_VAL(ac_cv_lib_$ac_lib_var,
[ac_save_LIBS="$LIBS"
LIBS="-l$1 $5 $LIBS"
AC_TRY_LINK(dnl
ifelse([$2], [main], , dnl Avoid conflicting decl of main.
[/* Override any gcc2 internal prototype to avoid an error.  */
]ifelse(AC_LANG, CPLUSPLUS, [#ifdef __cplusplus
extern "C"
#endif
])dnl
[/* We use char because int might match the return type of a gcc2
    builtin and then its argument prototype would still apply.  */
char $2 (void);
int (*MAIN__) (void);
]),
  [$2()],
  eval "ac_cv_lib_$ac_lib_var=yes",
  eval "ac_cv_lib_$ac_lib_var=no")
LIBS="$ac_save_LIBS"
])dnl
if eval "test \"`echo '$ac_cv_lib_'$ac_lib_var`\" = yes"; then
  AC_MSG_RESULT(yes)
  ifelse([$3], ,
[changequote(, )dnl
  ac_tr_lib=HAVE_LIB`echo $1 | sed -e 's/[^a-zA-Z0-9_]/_/g' \
    -e 'y/abcdefghijklmnopqrstuvwxyz/ABCDEFGHIJKLMNOPQRSTUVWXYZ/'`
changequote([, ])dnl
  AC_DEFINE_UNQUOTED($ac_tr_lib)
  LIBS="-l$1 $LIBS"
], [$3])
else
  AC_MSG_RESULT(no)
  ifelse([$4], , , [$4
])dnl
fi
])
