// vectors.cxx: Vectors class implementation.
//
// Copyright (C) 1999-2001 Frank C Langbein <frank@langbein.org>
//
// This program is free software; you can redistribute it and/or modify it 
// under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: vectors.cc 1 2005-08-10 23:35:07Z frank $

#include "config.h"

RCSID (vectors, "$Id: vectors.cc 1 2005-08-10 23:35:07Z frank $");

#include "interface.hxx"

#include "base/base_module.hxx"
#include "base/base.hxx"
#include "base/basetypes.hxx"

const char *Vectors::type = "Vectors";

Vectors::~Vectors ()
{
  VectorElement *w;
  while (head) {
    w = head->next;
    delete head;
    head = w;
  }
  if (material)
    delete material;
}

void Vectors::gl_render (bool inv)
{
  if (!material)
    material = new Material ();
  material->gl_material (inv);
  glBegin(GL_LINES);
  VectorElement *w = head;
  while (w) {
    glVertex3d (0.0, 0.0, 0.0);
    glVertex3d (w->u, w->v, w->w);
    w = w->next;
  }  
  glEnd();
  return;
}

void Vectors::add (double a, double b, double c)
{
  VectorElement *w = new VectorElement(a, b, c, head);
  head = w;
}

/// Local Variables:
/// exe-comm: "../sil"
/// compile-command: "cd .. && make"
/// End:
