// gcd.cxx: GCD implementation.
//
// Copyright (C) 1999-2001 Frank C Langbein <frank@langbein.org>
//
// This program is free software; you can redistribute it and/or modify it 
// under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: gcd.cc 1 2005-08-10 23:35:07Z frank $

#include "config.h"

RCSID (gcd, "$Id: gcd.cc 1 2005-08-10 23:35:07Z frank $");

#include "kernel/gcd.hxx"

unsigned long gcd (unsigned long a, unsigned long b)
{
  if (a < b) {
    unsigned long h = b;
    b = a;
    a = h;
  }
  while (b != 0) {
    a = a % b;
    if (a < b) {
      unsigned long h = b;
      b = a;
      a = h;
    }
  }
  return a;
}

/// Local Variables:
/// exe-comm: "../sil"
/// compile-command: "cd .. && make"
/// End:
