// kernel.hxx: Kernel API.
//
// Copyright (C) 1999-2001 Frank C Langbein <frank@langbein.org>
//
// This program is free software; you can redistribute it and/or modify it 
// under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: kernel.hxx,v 1.29.2.2 2001/08/16 16:19:09 scmfcl Exp $

#ifndef KERNEL_HXX
#define KERNEL_HXX 1

#include "kernel/types.hxx"
#include "interface.hxx"
#include "xmath.hxx"

class Solid;
class ParaSolid;
class Analyse;

#ifdef HAVE_ACIS
class BODY;
Solid *sil_convert (BODY *B, bool refs = true);
#endif // HAVE_ACIS

Analyse *sil_analyse (Solid *s, string const &n, string const &hn,
		      Real t_eq, Real t_len_dist, Real t_angle_dist,
		      Real t_ratio_approx, Real t_ratio_min, Real t_loop_dist,
		      unsigned long reg_angle_max_n,
		      unsigned long reg_fourier_coeff,
		      unsigned long reg_p_max_p, unsigned long reg_p_max_f,
		      unsigned long reg_p_min_f,
		      unsigned long reg_r_max_p, unsigned long reg_r_max_f,
		      unsigned long reg_p_min_f,
		      char **len_base, char **angle_base,
		      unsigned long max_pcbs,
		      bool reg_edges,
		      bool fa, bool fas, bool far, bool fl, bool fls, 
		      bool flr, bool fd, bool fdp, bool fpar, bool fcar,
		      bool fai, bool fap, bool farp, bool farc, bool fp,
		      bool fpp, bool fls, bool fg);

#endif // !KERNEL_HXX

/// Local Variables:
/// exe-comm: "../sil"
/// compile-command: "cd .. && make"
/// End:
