// scaner.hxx: Scanner API.
//
// Copyright (C) 1999-2001 Frank C Langbein <frank@langbein.org>
//
// This program is free software; you can redistribute it and/or modify it 
// under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: scanner.hxx,v 1.14.2.1 2001/08/16 16:19:17 scmfcl Exp $

#ifndef SCANNER_HXX
#define SCANNER_HXX 1

#include "list.hxx"

class RangePoints;

void sil_icrp (SimpleList<RangePoints> *views,
	       double max_dist,
	       double derr,
	       double spring_constant,
	       double minf,
	       double accel_damp,
	       double time_damp,
	       double dt0,
	       unsigned int preiter,
	       unsigned int max_iter1,
	       unsigned int max_iter2,
               bool anim);

void sil_cluster (RangePoints *pts, double dist);

#endif // !SCANNER_HXX

/// Local Variables:
/// exe-comm: "../sil"
/// compile-command: "cd .. && make"
/// End:
