// scanner_moudle.hxx: Scanner module.
//
// Copyright (C) 1999-2001 Frank C Langbein <frank@langbein.org>
//
// This program is free software; you can redistribute it and/or modify it 
// under the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 of the License, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
// or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 675 Mass Ave, Cambridge, MA 02139, USA.
//
// $Id: scanner_module.hxx,v 1.11.2.1 2001/08/16 16:19:17 scmfcl Exp $

#ifndef SCANNER_MODULE_HXX
#define SCANNER_MODULE_HXX 1

#include "module.hxx"

class ScannerModule : public Module {
public:
  ScannerModule ();
  ~ScannerModule ();
  void rollback_del (void *object);
  void draw_object (void *object, SimpleList<void> const &hirefs);
  void del_object (void *object);
  void load_file (FILE *fp, const char *format, bool ext, bool replace);
  void save_file (FILE *fp, const char *format, bool ext);
  const char **file_formats () const;
  const char *name () const;
private:
  static const char *fl_formats[7];
  static const char *nm;
};

#endif // !SCANNER_MODULE_HXX

/// Local Variables:
/// exe-comm: "../sil"
/// compile-command: "cd .. && make"
/// End:
